/**	<p>Diese Klasse stellt das Standardinterface fr die Implementierung des mareilschen Verschlsselungsalgorithmus dar.
Der mareilsche Algorithmus erlaubt das Ver- und Entschlsseln von 64 Byte groen Datenblcken. 
Der Algorithmus wird in der entsprechenden <a href="vsc.html">Dokumentation</a> genauer erklrt.
Diese Klasse beschreibt die Standardschnittstelle zur Implementation des Algorithmus.</p>
<p><b><big>
Diese Dokumentation ist zur Zeit noch nicht vollstndig, ich bitte um Verstndnis aber meine Zeit
ist leider sehr knap, aus diesem Grund kann es noch einen Moment dauern bis die vollstndige 
Dokumentation vorliegt.</big></b></p>
<p>
<hr>
    This program is free software; you can redistribute it and/or modify							<br>
    it under the terms of the GNU General Public License as published by							<br>
    the Free Software Foundation; either version 2 of the License, or								<br>
    (at your option) any later version.																<br>
																									<br>
    This program is distributed in the hope that it will be useful,									<br>
    but WITHOUT ANY WARRANTY; without even the implied warranty of									<br>
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the									<br>
    GNU General Public License for more details.													<br>
																									<br>
    You should have received a copy of the GNU General Public License								<br>
    along with this program; if not, write to the Free Software										<br>
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA						<br>
<hr>
</p>



<p>
<b>Bekannte Fehler:</b></p>
<p><table border=1>

<tr><th align=left>
Bisher keine bekannten Fehler.
</th></tr>

</table></p>



<p>
<b>nderungen am Interface:</b></p>
<p><table border=1>


<tr><th align=left width=20%>02.12.2000<br>Alexander Weber<br>--[Build 2]--</th>
<th align=left>
	Die Methode <i>isSafeCryptString</i> wird in das Interface offiziel aufgenommen und Untersttzt.
</th></tr>


<tr><th align=left width=20%>29.11.2000<br>Alexander Weber<br>--[Build 1]--</th>
<th align=left>
	Das Interface wird von mir zum ersten mal verffentlicht.
</th></tr>


</table></p>


@author (C) 2000, <a href="mailto:Alexander.Weber@myokay.net">Alexander Weber</a>
@version Version 1.0alpha (Build 2)
*/
public interface Crypt
{
// Methoden ab Version 1.0beta
//
	public int QueryCryptChar( char cDigit );
	public int[] QueryCryptString( String sPassword );
	public int[] QueryCryptKey( int[] StringKey );
	public int[] QueryCryptKey( String sPassword );
	public int[] CompleteCryptKey( int[] CryptKey );
	public int[] QueryCompleteCryptKey( String sPassword );
	public boolean isValidCryptKey( int[] CryptKey );
	public char[] EncryptBlock( char[] Data, int[] CryptKey );
	public char[] DecryptBlock( char[] Data, int[] CryptKey );
	public int[] RotateCryptKey( int[] CryptKey, boolean copy );
	public int[] DerotateCryptKey( int[] CryptKey, boolean copy );
	public boolean isSafeCryptString( int[] StringKey );

/*	Folgende Methoden sollen in Zukunft noch Untersttzt werden, ab der Betaversion, also 
	seien Sie auf die nderungen an der Schnittstelle vorbereitet !

	public boolean isValidDatablock( char[] Datablock );
	public long Datablock_Create( byte[] Source, char[] Datablock );
	public long Datablock_Append( byte[] Source, char[] Datablock );
	public long Datablock_Insert( byte[] Source, char[] Datablock, long Offset );
	public long Datablock_Delete( char[] Datablock, long Offset, long Size );
	public long Datablock_Alter( char[] Datablock, byte[] Dest, long Offset, long Size );
	public boolean Datablock_Destroy( char[] Datablock );

	public boolean EncryptDatablock( char[] Datablock, int[] CryptKey );
	public boolean DecryptDatablock( char[] Datablock, int[] CryptKey );
*/
}

